=== modified file 'juju/charm/tests/test_directory.py'
--- juju/charm/tests/test_directory.py	2012-10-23 03:30:14 +0000
+++ juju/charm/tests/test_directory.py	2012-11-02 17:56:58 +0000
@@ -3,7 +3,6 @@
 import hashlib
 import inspect
 import shutil
-import tempfile
 import zipfile
 
 from juju.errors import CharmError, FileNotFound
@@ -111,12 +110,12 @@
     def test_make_archive(self):
         # make archive from sample directory
         directory = CharmDirectory(sample_directory)
-        f = tempfile.NamedTemporaryFile(suffix=".charm")
-        directory.make_archive(f.name)
+        f = self.makeFile(suffix=".charm")
+        directory.make_archive(f)
 
         # open archive in .zip-format and assert integrity
         from zipfile import ZipFile
-        zf = ZipFile(f.name)
+        zf = ZipFile(f)
         self.assertEqual(zf.testzip(), None)
 
         # assert included
@@ -212,18 +211,18 @@
 
     def test_internal_symlink(self):
         charm_path = self.copy_charm()
-        with tempfile.NamedTemporaryFile(dir='/tmp') as external_file:
-            os.symlink(external_file.name, os.path.join(charm_path, "foobar"))
+        external_file = self.makeFile(content='baz')
+        os.symlink(external_file, os.path.join(charm_path, "foobar"))
 
-            directory = CharmDirectory(charm_path)
-            e = self.assertRaises(InvalidCharmFile, directory.as_bundle)
-            self.assertIn("foobar' Absolute links are invalid", str(e))
+        directory = CharmDirectory(charm_path)
+        e = self.assertRaises(InvalidCharmFile, directory.as_bundle)
+        self.assertIn("foobar' Absolute links are invalid", str(e))
 
     def test_extract_symlink(self):
         charm_path = self.copy_charm()
-        with tempfile.NamedTemporaryFile(dir='/tmp') as external_file:
-            os.symlink(external_file.name, os.path.join(charm_path, "foobar"))
+        external_file = self.makeFile(content='lorem ipsum')
+        os.symlink(external_file, os.path.join(charm_path, "foobar"))
 
-            directory = CharmDirectory(charm_path)
-            e = self.assertRaises(InvalidCharmFile, directory.as_bundle)
-            self.assertIn("foobar' Absolute links are invalid", str(e))
+        directory = CharmDirectory(charm_path)
+        e = self.assertRaises(InvalidCharmFile, directory.as_bundle)
+        self.assertIn("foobar' Absolute links are invalid", str(e))

